LeetCode-in-Java

2111. Minimum Operations to Make the Array K-Increasing

Hard

You are given a 0-indexed array arr consisting of n positive integers, and a positive integer k.

The array arr is called K-increasing if arr[i-k] <= arr[i] holds for every index i, where k <= i <= n-1.

In one operation, you can choose an index i and change arr[i] into any positive integer.

Return the minimum number of operations required to make the array K-increasing for the given k.

Example 1:

Input: arr = [5,4,3,2,1], k = 1

Output: 4

Explanation:

For k = 1, the resultant array has to be non-decreasing.

Some of the K-increasing arrays that can be formed are [5,6,7,8,9], [1,1,1,1,1], [2,2,3,4,4]. All of them require 4 operations.

It is suboptimal to change the array to, for example, [6,7,8,9,10] because it would take 5 operations.

It can be shown that we cannot make the array K-increasing in less than 4 operations.

Example 2:

Input: arr = [4,1,5,2,6,2], k = 2

Output: 0

Explanation:

This is the same example as the one in the problem description.

Here, for every index i where 2 <= i <= 5, arr[i-2] <= arr[i].

Since the given array is already K-increasing, we do not need to perform any operations.

Example 3:

Input: arr = [4,1,5,2,6,2], k = 3

Output: 2

Explanation:

Indices 3 and 5 are the only ones not satisfying arr[i-3] <= arr[i] for 3 <= i <= 5.

One of the ways we can make the array K-increasing is by changing arr[3] to 4 and arr[5] to 5.

The array will now be [4,1,5,4,6,5].

Note that there can be other ways to make the array K-increasing, but none of them require less than 2 operations.

Constraints:

Solution

import java.util.Arrays;

public class Solution {
    public int kIncreasing(int[] arr, int k) {
        int n = arr.length;
        int res = 0;
        int[] dp = new int[n / k + 5];
        for (int i = 0; i < k; i++) {
            int lis = 0;
            Arrays.fill(dp, 0);
            for (int j = i; j < n; j += k) {
                int low = 0;
                int high = lis;
                while (low < high) {
                    int mid = (low + high) >> 1;
                    if (arr[j] < dp[mid]) {
                        high = mid;
                    } else {
                        low = mid + 1;
                    }
                }
                dp[low] = arr[j];
                if (high == lis) {
                    lis++;
                }
            }
            res += lis;
        }
        return n - res;
    }
}